package example.controller
{
	import org.puremvc.interfaces.ICommand;
	import org.puremvc.patterns.command.SimpleCommand;
	import org.puremvc.interfaces.INotification;
	import example.model.CalclationProxy;
	import example.view.components.CalclationPanel;
	import example.view.CalclationPanelMediator;
	
	/**
	 * アプリケーション初期起動時実行コマンドクラス
	 */
	public class AppStartUpCommand extends SimpleCommand implements ICommand
	{
		/**
		 * 処理
		 */
		override public function execute(notification:INotification):void
		{
			// Proxyクラスをfacadeクラスに登録（ちなみに「facade」は静的に確保されているのでここでいきなり登場する）
			// Proxyクラスは実際にロジックを実装していくところで、そのインスタンスはfacadeクラスで一括管理される。
			facade.registerProxy( new CalclationProxy() );
			
			// VIEWコンポーネントの取得
			var app:PureMVC_Calclation = notification.getBody() as PureMVC_Calclation;
			
			// VIEWコンポーネントと関連するMediatorクラスの登録
			// Mediatorクラスは実際に画面へ値を表示するところを請け負うもの。
			// Proxyクラスへの橋渡しはこのMediatorクラスで行う。
			facade.registerMediator( new CalclationPanelMediator( app.calcPanel ));
			
		}
		
	}
}