package example.model
{
	import org.puremvc.interfaces.IProxy;
	import org.puremvc.patterns.proxy.Proxy;
	import mx.collections.ArrayCollection;
	/**
	 * Proxyクラス
	 * 実際の処理の実態をここで記述する
	 */
	public class CalclationProxy extends Proxy implements IProxy
	{
		// このクラスのNAMEプロパティの設定。このNAMEでfacade内のインスタンスは管理されるので、
		// これはプロジェクトでユニークになること
		public static const NAME:String = "CalclationProxy";
		// プロパティ
		private var _plusFlg:Boolean;
		private var _minusFlg:Boolean;
		private var _saveData:String;
		/**
		 * コンストラクタ
		 */
		public function CalclationProxy():void
		{
			// 親クラスのコンストラクタの呼び出し。
			// 第１引数は自分を示す文字列のNAMEを、
			// 第２引数はプロパティとして保持する型を
			// new演算子で指定してあげる。
			// こうすることで第２引数に指定された型が
			// dataというプロパティの型が設定される。
			super(NAME, new String );
			_plusFlg = false;
			_minusFlg = false;
			_saveData = "";
		}
		/**
		 * プロパティ値の取得
		 */
		public function get calcString():String
		{
			// dataという型のプロパティをキャストして（ここではStringにして）返却
			return data as String;
		}
		/**
		 * プロパティ値の設定
		 * 文字列を引数として渡された場合については
		 * 既存の文字列と結合する。
		 */
		public function set calcString(s:String):void
		{
			if(_plusFlg == true )
			{
				_saveData = calcString;
				data = s;
			}
			else if(_minusFlg == true )
			{
				_saveData = calcString;
				data = s;
			}
			else if( s.length == 0)
			{
				data = "";
			}
			else
			{
				data += s;
			}
		}
		/**
		 * 文字列をプロパティに設定
		 */
		public function setNumber(s:String):void
		{
			calcString = s;
		}
		/**
		 * 計算結果をプロパティに設定
		 */
		public function calcEqual():void
		{
			var result:int;
			if( this._plusFlg == true ) 
			{
				result = int(this._saveData) + int(calcString)
				calcString = result.toString();
				this._plusFlg = false;
				this._minusFlg = false;
				this._saveData = "";
			}
			else if( this._minusFlg == true )
			{
				result = int(this._saveData) - int(calcString)
				calcString = result.toString();
				this._plusFlg = false;
				this._minusFlg = false;
				this._saveData = "";
			}
			
		}
		/**
		 * 足し算するためのフラグをONにする
		 */
		public function plusNumber():void
		{
			this._plusFlg = true;
			this._minusFlg = false;
		}
		/**
		 * 引き算するためのフラグをONにする
		 */
		public function minusNumber():void
		{
			this._plusFlg = false;
			this._minusFlg = true;
		}
		/**
		 * すべてのクリア
		 */
		public function clear():void
		{
			calcString = "";
			this._saveData = "";
			this._plusFlg = false;
			this._minusFlg = false;
		}
	}
}